#pragma once

#include <gl/GL.h>
#include <gl/GLU.h>
#include "glut.h"

//#include "mathlib/vector.h"
#include "FlyingCam.h"
#include "terrain.h"
#include "model.h"

#include "resource.h"

class PlaneSim
{
public:
	PlaneSim();

	void OnIdle();

	LRESULT WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

private:
	static const int COLOR_BITS = 32, DEPTH_BITS = 32, STENCIL_BITS = 0;
	
	static const int MOVE_SPEED = 10;

	HWND m_hwnd;
	HDC m_hdc;
	int m_width;
	int m_height;

	FlyingCam m_cam;
	int m_oldX;
	int m_oldY;

	Terrain m_terrain;

	bool m_isBirdView;

	// light
	vector3 m_lightPos;

	// models
	static const int N_MODELS = 3;
	Model m_models[N_MODELS];
	Texture m_toonTexture;

	void DrawAxis(int len);
	void OnCreate();


};
