#include "stdafx.h"
#include "log.h"


void cftc_log(LogLevel ll, const char *srcfile, const char *func, int srcline, const char *format, ...)
{
	const int MaxBuf = 10240;
	char buf[MaxBuf] = {0};
	char vabuf[MaxBuf] = {0};

	va_list argptr;
	va_start(argptr, format);

	vsnprintf(vabuf, MaxBuf, format, argptr);

	va_end(argptr);

	if(ll == LogLevel_RAW)
	{
		strcpy_s(buf, MaxBuf, vabuf);
	}
	else
	{
		string level;
		bool details = false;

		switch(ll)
		{
		case LogLevel_TRACE:
			level = "TRACE";
			break;

		case LogLevel_INFO:
			level = "INFO ";
			break;

		case LogLevel_DEBUG:
			level = "DEBUG";
			break;

		case LogLevel_WARN:
			level = "WARN ";
			details = true;
			break;

		case LogLevel_ERROR:
			level = "ERROR";
			details = true;
			break;

		case LogLevel_FATAL:
			level = "FATAL";
			details = true;
			break;
		}

		SYSTEMTIME st;
		GetLocalTime(&st);

		if(details)
		{
			sprintf_s(buf, MaxBuf, "%04d/%02d/%02d %02d:%02d:%02d:%03d [%s] %s (in %s:%d (%s))", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds,
				level.c_str(), vabuf, srcfile, srcline, func);
		}
		else
		{
			sprintf_s(buf, MaxBuf, "%04d/%02d/%02d %02d:%02d:%02d:%03d [%s] %s", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds,
				level.c_str(), vabuf);
		}
	}

	cout << buf << endl;

	// write to file
	const string filename = "log.txt";

	FILE *fp = fopen(filename.c_str(), "a");

	fputs(buf, fp);
	fputs("\r\n", fp);
	//fflush(fp);

	fclose(fp);

}
