#ifndef LOGGER_H
#define LOGGER_H

#include <iostream>

using namespace std;

enum LogLevel
{
	LogLevel_RAW,
	LogLevel_TRACE,
	LogLevel_INFO,
	LogLevel_DEBUG,
	LogLevel_WARN,
	LogLevel_ERROR,
	LogLevel_FATAL
};

void cftc_log(LogLevel ll, const char *srcfile, const char *func, int srcline, const char *format, ...);

#define RAW_LOG(format, ...) cftc_log(LogLevel_RAW, __FILE__, __FUNCTION__, __LINE__, format, ##__VA_ARGS__)
#define TRACE_LOG(format, ...) cftc_log(LogLevel_TRACE, __FILE__, __FUNCTION__, __LINE__, format, ##__VA_ARGS__)
#define INFO_LOG(format, ...) cftc_log(LogLevel_INFO, __FILE__, __FUNCTION__, __LINE__, format, ##__VA_ARGS__)
#define DEBUG_LOG(format, ...) cftc_log(LogLevel_DEBUG, __FILE__, __FUNCTION__, __LINE__, format, ##__VA_ARGS__)
#define WARN_LOG(format, ...) cftc_log(LogLevel_WARN, __FILE__, __FUNCTION__, __LINE__, format, ##__VA_ARGS__)
#define ERROR_LOG(format, ...) cftc_log(LogLevel_ERROR, __FILE__, __FUNCTION__, __LINE__, format, ##__VA_ARGS__)
#define FATAL_LOG(format, ...) cftc_log(LogLevel_FATAL, __FILE__, __FUNCTION__, __LINE__, format, ##__VA_ARGS__)

#endif