#pragma once

#include <vector>
#include <string>

#include "mathlib/vector.h"
#include "mathlib/sphere.h"
#include "mathlib/matrix.h"
#include "terrain.h"
#include "FlyingCam.h"


using namespace std;


class Model
{
public:
	bool Load(const string &filename, Texture *toonTexture, float x, float z, float yoffset, float radius, float speed);
	void Render(const FlyingCam &cam, const Terrain &terrain, vector3 lightpos);

	const sphere &GetSphere() {return m_sphere;}

private:
	enum MODEL_PARSE_STATE
	{
		N_VERTS,
		VERTS,
		//	N_FACES,	// ignore
		FACES,
		END
	};

	vector<vector3> m_verts;
	vector<vector3> m_faces;
	vector<vector3> m_norms;

	vector3 m_basePos;
	sphere m_sphere;	// ġ .
	float m_lowerY;
	float m_yOffset;

	float m_rotRadius;	// ȸ ݰ
	float m_rotAngle;
	float m_rotSpeed;

	Texture *m_pToonTexture;

};