#include "stdafx.h"
#include "texture.h"


Bitmap::Bitmap()
{
	m_imgRec = 0;
	m_data = 0;
	m_width = m_height = 0;
}

Bitmap::~Bitmap()
{
	clear();
}

void Bitmap::clear()
{
	if(m_data)
		free(m_data);
	if(m_imgRec)
		free(m_imgRec);

	m_imgRec = 0;
	m_data = 0;
	m_width = m_height = 0;
}

bool Bitmap::load(const TCHAR *filename)
{
	clear();

	if((m_imgRec = auxDIBImageLoad(filename)) == 0)
		return false;

	m_data = m_imgRec->data;
	m_width = m_imgRec->sizeX;
	m_height = m_imgRec->sizeY;

	return true;
}

const BYTE *Bitmap::getData() const
{
	return m_data;
}

int Bitmap::getWidth() const
{
	return m_width;
}

int Bitmap::getHeight() const
{
	return m_height;
}





Texture::Texture()
{
	m_texID = 0;
	//	m_width = m_height = 0;
}

void Texture::create(const Bitmap &bm, UINT texwrap, UINT filter)
{
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, filter);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, filter);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, texwrap);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, texwrap);

	glGenTextures(1, &m_texID);

	glBindTexture(GL_TEXTURE_2D, m_texID);
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, bm.getWidth(), bm.getHeight(), GL_RGB, 
		GL_UNSIGNED_BYTE, bm.getData());
}

void Texture::bind()
{
	glBindTexture(GL_TEXTURE_2D, m_texID);
}
